/* suggest programmers interface example V2.00 Feb 96 */

#include <stdio.h>
#include <qdos.h>
#include <things.h>
#include <string.h>
#include "suggestuser_h"

#define  STACKSPC               5000
#define  ROOT_CUT_MAX           4

#define  WINDOW                 20
#define  BUFSIZE                4

#define  MINVERS                '2'

#define  VERSINDX(n, v)         (((char *)(&v))[n])

long _stack=STACKSPC;

static int fail(char *at, long code)
{
   if(code > ERR_BL)
        ut_err(code, fgetchid(stderr));
   else
        printf("%s\n", (char *)(code & 0x8fffffff));

   printf("at %s\n", at);

   return code;
}

int main(int argc, char *argv[])
{
        chanid_t                spell;
        long                    n, k;
        short                   newword=1, cnt=2;
        struct GLOBALS          *globals;
        struct SUGGEST_HEAD     *suggest;
        struct LQLSTR           *note;
        THING_LINKAGE           *link;
        long                    d2=0, v;
        char                    *a2=NULL, buf[BUFSIZE];
        char                    *suggest_name="suggest", *spell_name="spell";

        /* anything to do ? */
        if(argv[1] == NULL)
                return fail("Argument Count", ERR_BP);

        /* find suggest thing */
        if((long)(suggest=(struct SUGGEST_HEAD *)sms_uthg(suggest_name, \
                -1, -1, &d2, NULL, &v, &link)) < 0)
                        return fail("sms_uthg", (int)suggest);

        printf("suggest thing version %c%c%c%c\n", VERSINDX(0, v), \
                VERSINDX(1, v), VERSINDX(2, v), VERSINDX(3, v));

        /* if version too old */
        if(VERSINDX(0, v) < MINVERS)
             return fail("SUGGEST VERSION", ERR_NI);

        /* open a spell channel, if no dictinary then load */
        if((spell=io_open(spell_name, OLD_SHARE)) < 0)
                if((spell=io_open(spell_name, NEW_EXCL)) < 0)
                        return fail("open spell", spell);

        /* allocate suggest global area */
        if((n=(*suggest->alloc_global_P)(&globals, spell, NULL, -1, -1, -1)) < 0)
                return fail("alloc_globals", n);

        /* set stack limit */
        if((n=(*suggest->stacklimit_P)(globals, ((char *)&argc) - STACKSPC + 12)) < 0)
                return fail("stacklimit", n);

        /* use SPELL device to parse input string */
        if((n=io_sstrg(spell, -1, argv[1], strlen(argv[1]))) < 0)
           if(n != ERR_NF)
                return fail("io_sstrg", n);

        if((n=io_fstrg(spell, -1, globals->word, MAXWORD - 1)) < 0)
                return fail("io_fstrg", n);

        globals->word[n]=0;

        /* check the history */
        if((globals->alltype=(ALLTYPE)(*suggest->check_all_P)(globals->allrec, \
                        &(globals->allbuf), globals->word, NULL)) > 0)
           printf("History is %s %s\n", (globals->alltype == EXPLICIT ?\
                        "Explicit" : "Implicit"), globals->allbuf.s);
        else
           printf("No History\n");

        printf("Suggestions for %s\n", globals->word);

        /* and find suggestions */
        do
        {
                if((n=(*suggest->findwords_P)(globals, newword)) < 0)
                        return fail("findwords", n);

                newword=0;

                printf("Root Cut %d\n", globals->root_cut);

                cnt++;

                for(k=0; k < n; k++)
                {
                        note=(*suggest->find_note_P)(WORD_REF(globals,k));

                        printf("%-30s %s\n", CSTRING_REF(globals,k),\
                                (note == NULL ? "" : note->s));

                        if(( ((++cnt) % WINDOW) == 0) && (fgetchid(stdin) ==\
                                fgetchid(stdout)))
                        {
                                printf("Press Enter to continue\n");
                                fgets(buf, BUFSIZE, stdin);
                        }
                }
        }
        while((++globals->root_cut) < ROOT_CUT_MAX);

        /* don't really need to do this if terminating */
        (void)(*suggest->freemem_P)(globals);
        (void)sms_fthg(suggest_name, -1, &d2, 0, NULL, &a2);

        return 0;
}
